// Copyright 2012, 2013 Brad Block, Pawjaw, LLC. (an Ohio Limited Liability Company)
// 
// This file is part of JBTCRF.
// 
// JBTCRF is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// JBTCRF is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with JBTCRF.  If not, see <http://www.gnu.org/licenses/>.

package com.pawjaw.classification.crf.lmcbt.configurations;

public class DefaultConfiguration extends Configuration {
    public DefaultConfiguration(int point_features, int window_radius, int label_count_excluding_start_label) {
        super(point_features, window_radius, label_count_excluding_start_label);
    }

    @Override
    protected int getSplitterThreads() {
        return 4;
    }

    @Override
    protected int getMaxLeavesPerTree() {
        return 20;
    }

    @Override
    protected int getBoostedTreeThreads() {
        return 4;
    }

    @Override
    protected int getMaxBoostingIterations() {
        return 1000;
    }

    @Override
    protected int getMinBoostingIterations() {
        return 75;
    }

    @Override
    protected int getBoostingIterationsBetweenTests() {
        return 10;
    }

    @Override
    protected double getRegressionTreeShrinkage() {
        return 40;
    }

    @Override
    protected double getMinRelativeAccuracyImprovement() {
        return 5e-4;
    }

    @Override
    protected boolean getReportTrainingProgress() {
        return true;
    }

    @Override
    protected boolean getCacheExpandedTrueFeatures() {
        return true;
    }
}
