// Copyright 2012, 2013 Brad Block, Pawjaw, LLC. (an Ohio Limited Liability Company)
// 
// This file is part of JBTCRF.
// 
// JBTCRF is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// JBTCRF is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with JBTCRF.  If not, see <http://www.gnu.org/licenses/>.

package com.pawjaw.classification.crf.lmcbt.points;

import com.pawjaw.classification.crf.lmcbt.configurations.Configuration;

public class DensePoint implements Point {
    private int[] posfs;
    private boolean[] feature_f;

    public void setFeatures(boolean[] bs) {
        int f, F = bs.length, n = 0, N = 0;
        this.feature_f = bs;
        for(f = 0;f < F;f++)
            if(bs[f])
                N++;
        posfs = new int[N];
        for(f = 0;f < F;f++)
            if(bs[f])
                posfs[n++] = f;
    }

    public boolean hasTrueFeature(Configuration c, int feature_index) {
        return feature_f[feature_index];
    }

    public int nextTrueFeature(Configuration c, int offset) {
        if(offset < 0 || offset >= posfs.length)
            return -1;
        else
            return posfs[offset];
    }

    public int trueFeatureCount() {
        return posfs.length;
    }
}
