// Copyright 2012, 2013 Brad Block, Pawjaw, LLC. (an Ohio Limited Liability Company)
// 
// This file is part of JBTCRF.
// 
// JBTCRF is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// JBTCRF is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with JBTCRF.  If not, see <http://www.gnu.org/licenses/>.

package com.pawjaw.classification.crf.lmcbt.readers;

import com.pawjaw.classification.crf.lmcbt.points.Point;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.List;

public abstract class LabeledSequenceDataReader {
    public abstract void readPoints(List<Point[]> pointss, List<int[]> true_labelss, BufferedReader br) throws IOException;

    public abstract int getPointFeatureCount();

    public abstract int getLabelCount();
    
    public void readFile(List<Point[]> pointss, List<int[]> true_labelss, File f) throws IOException {
        BufferedReader br = new BufferedReader(new FileReader(f));
        readPoints(pointss, true_labelss, br);
        br.close();
    }
}
