// Copyright 2012, 2013 Brad Block, Pawjaw, LLC. (an Ohio Limited Liability Company)
// 
// This file is part of JBTCRF.
// 
// JBTCRF is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// JBTCRF is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with JBTCRF.  If not, see <http://www.gnu.org/licenses/>.

package com.pawjaw.classification.crf.lmcbt.trees;

import java.util.List;

public class Node {
    public int split_feature = -1;
    public double output;
    public Node true_child = null;
    public Node false_child = null;
    public int[] example_indexes;

    public Node(List<Integer> example_indexes) {
        this(0, example_indexes);
    }

    public Node(int[] example_indexes) {
        this(0, example_indexes);
    }

    public Node(double output, List<Integer> example_indexes) {
        int i = 0;
        this.output = output;
        this.example_indexes = new int[example_indexes.size()];
        for(int example_index : example_indexes)
            this.example_indexes[i++] = example_index;
    }

    public Node(double output, int[] example_indexes) {
        this.output = output;
        this.example_indexes = example_indexes;
    }

    public boolean isLeaf() {
        return true_child == null || false_child == null;
    }
}
