// Copyright 2012, 2013 Brad Block, Pawjaw, LLC. (an Ohio Limited Liability Company)
// 
// This file is part of JBTCRF.
// 
// JBTCRF is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// JBTCRF is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with JBTCRF.  If not, see <http://www.gnu.org/licenses/>.

package com.pawjaw.classification.crf.lmcbt.trees;

public class Split implements Comparable<Split> {
    public int split_feature = -1;
    public double gain = 0;
    public double true_child_output = 0;
    public double false_child_output = 0;
    public Node parent = null;

    public Split(Node parent) {
        this.parent = parent;
    }

    public boolean isValid() {
        return split_feature >= 0;
    }

    public int compareTo(Split o) {
        return gain > o.gain ? -1 : 1;
    }
}
